version 5
set matsize 400
set more 1
clear
capture log close
log using new99a, replace
use new99a

rename abort y

gen a=year>1988
gen a2=year<1990
gen b=year==1992
gen b2=year~=7
gen c=year==1986
gen tr=year-1980
gen tr2=tr^2
gen tr3=tr^3

gen pr=0

* gen g_1=g==1

xi i.year


renpfix I



drop year


* matrix b0=(.248)
* mat coleq b0=tau
* mat colnames b0=_cons

* first do saturated model
ml begin
ml function mouw
ml method lf
eq v:  y year* 
eq tau: year* 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1 tau 0 1)
* set trace on
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest, saving(0)


* constrained model m1
ml begin
ml function mouw
ml method lf
eq v: y year*
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest, saving(2)



lrtest

sum tr*


* m2
ml begin
ml function mouw
ml method lf
eq v: y year*
eq tau: a 
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m3
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a 
eq m: year*
ml model b= v tau m,  from(b0) depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m4
ml begin
ml function mouw
ml method lf
eq v: y tr
eq tau: a 
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m5
ml begin
ml function mouw
ml method lf
eq v: y c 
eq tau: a 
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* m6
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a 
eq m: 
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m7
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a 
eq m: tr
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest



* m8
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a a2
eq m: b b2
ml model b= v tau m, cons(100) depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


/*

* a1 constrained model, const. var
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

*  test
ml begin
ml function mouw
ml method lf
eq v: y a
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m10 constrained model, const. var
ml begin
ml function mouw
ml method lf
eq v: y a c
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* test
ml begin
ml function mouw
ml method lf
eq v: y a c
eq tau: 
eq m: 
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest




* a11 constrained model, const. var
ml begin
ml function mouw
ml method lf
eq v: y a c
eq tau: 
eq m: a
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* test
ml begin
ml function mouw
ml method lf
eq v: y b c
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* a2 constrained model, trend in variance
ml begin
ml function mouw
ml method lf
eq v: y tr
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* a3 constrained model, trend in variance
ml begin
ml function mouw
ml method lf
eq v: y tr tr2
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* a4 constrained model, trend in variance
ml begin
ml function mouw
ml method lf
eq v: y tr tr2 tr3
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal


lrtest, using(2)
lrtest


* a5 constrained model, trend in variance
ml begin
ml function mouw
ml method lf
eq v: y b
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* a2 constrained model, trend in variance, const. mean
ml begin
ml function mouw
ml method lf
eq v: y tr*
eq tau: 
eq m: 
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal





lrtest


* a3 constrained model, trend in variance, const mean +1992
ml begin
ml function mouw
ml method lf
eq v: y tr*
eq tau: 
eq m: b
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal





lrtest

