version 5
set matsize 400
set more 1
clear
capture log close
log using new99b, replace
use new99b

rename aborto y

/*
gen a=year>1988
gen a2=year<1990
gen b=year==1992
gen b2=year~=7
gen c=year==1986
*/
gen tr=year-1974

gen pr=0

* gen g_1=g==1

xi i.year
renpfix I

drop year


* matrix b0=(.248)
* mat coleq b0=tau
* mat colnames b0=_cons

* first do saturated model
ml begin
ml function mouw
ml method lf
eq v:  y year* 
eq tau: year* 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1 tau 0 1)
* set trace on
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest, saving(0)



* constrained model
ml begin
ml function mouw
ml method lf
eq v: y year*
eq tau: 
eq m: year*
ml model b= v tau m,   depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal





lrtest



* m2
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau:  
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m2b=m1+constant mean
ml begin
ml function mouw
ml method lf
eq v: y year* 
eq tau:  
eq m: 
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* m2c=m2+linear trend in means
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau:  
eq m: tr*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* m3
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau:  
eq m: 
ml model b= v tau m,  from(b0) depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

/*

* m4
ml begin
ml function mouw
ml method lf
eq v: y tr
eq tau: a 
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m5
ml begin
ml function mouw
ml method lf
eq v: y c 
eq tau: a 
eq m: year*
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest


* m6
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a 
eq m: 
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest

* m7
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a 
eq m: tr
ml model b= v tau m,  depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest



* m8
ml begin
ml function mouw
ml method lf
eq v: y 
eq tau: a a2
eq m: b b2
ml model b= v tau m, cons(100) depv(100)
ml sample mysamp
* ml search, limits(v 0 1  tau 0 1)
ml maximize f V, trace
ml post normal
ml mlout normal

lrtest
